var cqrPageSelection = "";
var cqrPageURL = "";
var cqrPageHost = "";
var cqrLinkURL = "";
var cqrImgName = "";
var cqrImgURL = "";
var cqrPageTitle = "";

var cqrAction = "";
var cqrActionPrompt = "";
var cqrConfigLastWillId = "";
var cqrConfigLastWillCtrl = false;
var cqrTabRef = "";
var cqrWndRef = "";
if (cqrMailFlag){
    var cqr_browser = getMessageBrowser();
}else{
    if (cqr_platform.search(/OS X/)) {
      var cqr_browser = document.getElementById("content");
    } else {
      var cqr_browser = getBrowser();
    }
}
//Inits
conQueryInit();

function conQueryInit(){
    prfs_LoadMain();
    lastDirState = rdir(cqrPlugsDir);
    srcDirChanged();
    plg_QuickLoadAll();
}

//Tools menu handler
function HandleToolsMenu(event){
try{
    if (event.target.childNodes[0] && 
       (event.target.childNodes[0].id == "menu_ToolsPopup" || 
       event.target.childNodes[0].id == "taskPopup")){
        var cqr_cfg = window.document.getElementById('cq-cfg-menu');
        //This will require restarting, i know, but perfomance is important :)
        //cqrHideFromTools = prfs_ReadItem("Main.HideFromTools");
        if (cqr_cfg) cqr_cfg.hidden = cqrHideFromTools;
  }
}catch(err){cqerr(err, "HandleToolsMenu sub")}
}

/// HotMenu. Many thanks to Henrik Gulbrandsen for developing this!
function RegisterContextMenuListener(){
  cqr_browser.addEventListener("contextmenu", HandleContextMenu, true);
}

function HandleInsertedNode(event){
//dump(event.target.id + "\n");
// somehow this sub breaks up the top menu ("File", "Edit" e.t.c) of Mozilla 1.7a, bild 2004010508
// ...and somehow HotMenu works without this :))
//  if (event.target.id == "content"){
//    RegisterContextMenuListener();
//  } 
}

document.addEventListener("DOMNodeInserted", HandleInsertedNode, false);
document.addEventListener("DOMMenuItemActive", HandleToolsMenu, true);
RegisterContextMenuListener();

function HandleContextMenu(event){
  getPageParams(event);
  
  var kShift = "";
  if (event.shiftKey || event.ctrlKey ){kShift = "yes"}
  
  prfs_LoadMain();
  if ((kShift) && (cqrUseHotMenu)){
    //var box = getBrowser().boxObject;
    var box = cqr_browser.boxObject;
    MouseX = event.screenX - box.screenX + box.x;
    MouseY = event.screenY - box.screenY + box.y;

    document.popupNode = event.target;
    event.preventDefault();
    hotmenu(kShift, MouseX, MouseY);
  } else {
    //FillMenu(kShift)
    FillMainMenu();
  }
}

function hotmenu(kShift, x, y){
try{
  var hotmenu = window.document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = window.document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    window.document.documentElement.appendChild(hotmenu);
  }
  FillMenu(kShift, "");
  hotmenu.showPopup(cqr_browser, x, y, "context", "", "");
  hotmen.setAttribute("position", "after_pointer"); //at_pointer
}catch(er){cqerr(er, "hotmenu sub")}
}

function FillMainMenu(){
try{
    var doc = window.document;
    var dataUpdated = false;
    if (cqrMailFlag) {
        var bContextMenu = doc.getElementById("messagePaneContext");
    } else {
        var bContextMenu = doc.getElementById("contentAreaContextMenu");
    }
    var cqmenu = doc.getElementById("cq-menu");
    cqmenu.hidden = cqrHideQueryTo;
    var entriesTrash = [];
    for (i=0; i < bContextMenu.childNodes.length; i++){
        if (bContextMenu.childNodes[i].getAttribute("conquery_flag")!=""){
            entriesTrash.push(bContextMenu.childNodes[i]);
        }
    }
    for (each in entriesTrash) bContextMenu.removeChild(entriesTrash[each]);
  
    if (cqrMainContextLimit > 0){
        bContextMenu.insertBefore(crtSeparator(doc), cqmenu);
        lastDirState = rdir(cqrPlugsDir);
        if (srcDirChanged()) {
            updated = "true";
            plg_QuickLoadAll();
        } else {
            prfs_UpdateEntries();
        }
        //getPageParams();  
        dataUpdated = true;
        
        var entries = EntryHash.mainSet(cqrMainContextLimit);
        for (id in entries){
            evalContext(entries[id]);
            bContextMenu.insertBefore(crtMenuItem(doc, entries[id], "mainSet"), cqmenu);
        }
    }

    if (!cqrShowCSPInMainMenu) return;
  
    if (!dataUpdated){
        lastDirState = rdir(cqrPlugsDir);
        if (srcDirChanged()) {
            updated = "true";
            plg_QuickLoadAll();
        }
        prfs_UpdateEntries();
    }

    entries = EntryHash.showifSet();
    for (entry in entries){
        if (evalContext(entries[entry])) {
            bContextMenu.insertBefore(crtMenuItem(doc, entries[entry], "showifSet"), cqmenu);
        }
	}
}catch(er){cqerr(er, "FillMainMenu sub")}
}

function FillMenu(kShift, allshowif){
try{
    var doc = window.document;
    var updated = false;
    var recommend = [];
    
    prfs_LoadMain();
    lastDirState = rdir(cqrPlugsDir);
    if (srcDirChanged()){
        updated = "true";
        plg_QuickLoadAll();
    }
    prfs_UpdateEntries();
    
    if ((kShift) && (cqrUseHotMenu)) {
        var ppMenu = doc.getElementById("cq-hotmenu");
        var entries = EntryHash.conquerySet(0);
        var forceCSPShowInMain = true;
    } else {
        var ppMenu = doc.getElementById("cq-ppm");
        var entries = EntryHash.conquerySet(cqrMainContextLimit);
        var forceCSPShowInMain = false;
    }
    
    while (ppMenu.hasChildNodes()) ppMenu.removeChild(ppMenu.lastChild);
    for (entry in entries) {
        evalContext(entries[entry]);
        ppMenu.appendChild(crtMenuItem(doc, entries[entry], "conquerySet"));
    }
    
    if (!cqrShowCSPInMainMenu || forceCSPShowInMain){
        entries = EntryHash.showifSet();
        for (entry in entries){
            if (evalContext(entries[entry])) {
                ppMenu.appendChild(crtMenuItem(doc, entries[entry], "showifSet"))
            }
        }
    }
    
    lastDirState = null;
    ppMenu = null;
    ppItem = null;
    entries = null;
}catch(er){cqerr(er, "FillMenu")}
}

function crtSeparator(doc){
    retItem = doc.createElement("menuseparator");
    retItem.setAttribute("conquery_flag", "conquery");
    return retItem;
}

function crtMenuItem(doc, entry, flag){
  var retItem = doc.createElement("menuitem");
  retItem.setAttribute("class", "menuitem-iconic");
    if (!entry.iconpath){
      if (cqrHTTPIcon){
          icourl = url2host(entry.Action);
          if (icourl) {retItem.setAttribute("image", icourl + "/favicon.ico")};
      }
    }else{
      retItem.setAttribute("image", "file://" + entry.iconpath);
    }
  retItem.setAttribute("label", entry.Title);
  retItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
  retItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entry.eId+"')");
  retItem.setAttribute("conquery_flag", flag);
  return retItem;
}

function detecttrg(evnt){
 if (evnt.originalTarget.localName == "menuseparator") FillMenu(false,true);
}

function ProcessEntry(ctrl, EntryId){
	var entry = EntryHash._Item(EntryId);
	if (ctrl) cqrShowAlternatives = true;
	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = plg_ReadData(entry.filepath);
        entry.Context = EntryHash.Items[EntryId].Context;
        entry.lastmatch = EntryHash.Items[EntryId].lastmatch;
		EntryHash._AddEntryObj(entry, entry.eId);
	}
    PrepareAction(entry);
	if (cqrcancel){
		resetenv();
		return;
	}

    if (cqrMailFlag){
    //doc = window.document;
        try{
            if (entry.Action){
                var cqrurl = cqrAction;
            } else {
                var cqrurl = entry.Action;
            }
            firstpass = true;
            for (each in QueryHash){
                if (firstpass){
                    cqrurl = cqrurl + "?" + each + "=" + QueryHash[each];
                    firstpass = false;
                } else {
                    cqrurl = cqrurl + "&" + each + "=" + QueryHash[each];
                }
            }
            var mess = Components.classes["@mozilla.org/messenger;1"].getService(Components.interfaces.nsIMessenger);
            mess.launchExternalURL(encodeURI(cqrurl));
            resetenv();
            return;
        }catch(er){cqerr(er, "ProcessEntry sub (mail)")}
    }


    //var cqr_browser = getBrowser();
    if ((cqrAction) && (!entry.Inputs)){
        if (cqrOpenRes != "win_fg") {
             tab = cqr_browser.addTab(cqrAction);
             if (cqrOpenRes == "tab_fg") cqr_browser.selectedTab = tab;
        }else{
             window.open(cqrAction);
        }
        resetenv();
        return;
    }

    if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
        myTabRef = window.open();
        if (cqrOpenRes == "win_bg") window.focus();
    } else {
        if (cqrPageURL == 'about:blank'){
            myTabRef = cqr_browser.selectedTab;
        }else{
            myTabRef = cqr_browser.addTab();
            if (cqrOpenRes == "tab_fg") cqr_browser.selectedTab = myTabRef;
        }
    }
    window.setTimeout('formIt("'+ EntryId + '");', 70);
}

function formIt(EntryId){
var entry = EntryHash._Item(EntryId);
    if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
        doc = myTabRef.document;
    } else {
        tabBr = cqr_browser.getBrowserForTab(myTabRef);
        doc = tabBr.contentDocument;
    }

    try{
      var sbmt = null;
      var frm = doc.createElementNS("http://www.w3.org/1999/xhtml", "form");
      frm.setAttribute("name", "cqrform");
      if (entry.Action){
        frm.setAttribute("action", cqrAction);
      } else {
        frm.setAttribute("action", entry.Action);
      }
      frm.setAttribute("method", entry.Method);
      frm.setAttribute("style", "display: none;");
      frm.setAttribute("accept-charset", entry.qcharset);
      if (cqrMailFlag) frm.setAttribute("target", "_blank");
      for (each in QueryHash){
          // we should be aware of <input name="submit"> :))
          if (each == "submit"){
              sbmt = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
              sbmt.setAttribute("type", "submit");
              sbmt.setAttribute("name", each);
              sbmt.setAttribute("value", unescape(QueryHash[each]));
              frm.appendChild(sbmt);
              continue;
          }
          var inp = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
          inp.setAttribute("type", "hidden");
          inp.setAttribute("name", each);
          inp.setAttribute("value", unescape(QueryHash[each]));
          frm.appendChild(inp);
      }
      doc.documentElement.appendChild(frm);
      if (sbmt!=null){
          frm.submit.click();
      } else {
          frm.submit();
      }
    } catch(er){cqerr(er, "formIt sub")}
    resetenv();    
}

function PrepareAction(EntryObj){
try{
  cqrAction = SubstVars(EntryObj.Action, EntryObj);
  for (i in EntryObj.Inputs){
    QueryHash[EntryObj.Inputs[i].def.name] = SubstVars(EntryObj.Inputs[i].def.value, EntryObj);
  }
  if (cqrShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function SubstVars(str, EntryObj){
    var retstr = "";
    //ire = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");
    cqrvars = cqrSIRe.exec(str);
    //si_target = EntryObj.sitarget;
    lastind = 0;
    if (cqrvars){
      while (cqrvars){
        tmpstr = str.substring(lastind, cqrSIRe.lastIndex);
        switch("[:"+cqrvars[1]+"]"){
          case "[:selection]":
            if (!cqrPageSelection) cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:selection]", cqrPageSelection);
            break;
          case "[:url]":
            retstr += tmpstr.replace("[:url]", cqrPageURL);
            break;
          case "[:linkurl]":
            retstr += tmpstr.replace("[:linkurl]", cqrLinkURL);
            break;
          case "[:imgurl]":
            retstr += tmpstr.replace("[:imgurl]", cqrImgURL);
            break;
          case "[:imgname]":
            retstr += tmpstr.replace("[:imgname]", cqrImgName);
            break;
          case "[:host]":
            retstr += tmpstr.replace("[:host]", cqrPageHost);
            break;
          case "[:title]":
            retstr += tmpstr.replace("[:title]", cqrPageTitle);
            break;
          case "[:text]":
            retstr += tmpstr.replace("[:text]", "");
            break;
          case "[:matched]":
            var matchnum = Number(cqrvars[3]);
            if (isNaN(matchnum)) matchnum = 0;
            if (EntryObj.lastmatch[matchnum]){
              retstr += tmpstr.replace(cqrvars[0], EntryObj.lastmatch[matchnum]);
            }else{
              retstr += tmpstr.replace(cqrvars[0], "");
            }
            break;
          case "[:prompt]":
            cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:prompt]", "");
            break;
          //if variable is not recognized
          default:
            retstr += tmpstr;
        }
      //ire.lastIndex = 0;
      lastind = cqrSIRe.lastIndex;
      cqrvars = cqrSIRe.exec(str);
      }
      retstr += str.substring(lastind);
    } else {retstr = str}
    return retstr;
}

function processRe(){

}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", cqrMess.GetStringFromName('cqr.cfg.wTitle'), "centerscreen,chrome,modal,resizable=yes");
  if (cqrConfigLastWillId){
    ProcessEntry(cqrConfigLastWillCtrl, cqrConfigLastWillId);
    cqrConfigLastWillId = "";
  }
}

function evalContext(entryObj){
    if (entryObj.showif == "") return false;
    
    var res = new Object;
    trg = SubstVars(entryObj.sitarget, entryObj);
    cqrShowAlternatives=false;
    res = entryObj.si_compiled.exec(trg);
    entryObj.si_compiled.lastIndex=0;
    if (res){
        EntryHash.Items[entryObj.eId].lastmatch = res;
        //show("Matched values for " + EntryHash.Items[entry].Title + ":");
        //for (each in res) show(each + ": " + res[each]);
        return true;
    } else {
        EntryHash.Items[entryObj.eId].lastmatch = [];
        EntryHash.Items[entryObj.eId].lastmatch[0] = trg;
        return false;
    }
}

function getPageParams(event){
    var focusedWindow = document.commandDispatcher.focusedWindow;
    try{
        cqrPageSelection = "";
        //Thanks to Yuriy for textbox & textarea selection extraction
        var node = event.explicitOriginalTarget;
        if ((node) && 
            ((node.nodeName.toUpperCase() == "TEXTAREA") ||
            (node.nodeName.toUpperCase() == "INPUT" && node.type == "text"))) {
            cqrPageSelection = node.value.substring(node.selectionStart, node.selectionEnd);
        }else{
            //Thanks for to Shanmuhanathan T for this patch for FF 1.0.3
            //http://bugzilla.mozdev.org/show_bug.cgi?id=9890#c2
            cqrPageSelection = focusedWindow.getSelection.call(focusedWindow).toString();
        }
	}catch(er){cqrPageSelection=""}

    try{
        cqrPageURL = focusedWindow.location.href;
	}catch(er){cqrPageURL=""}
	
	try{
	  	cqrPageHost = focusedWindow.location.host;
	}catch(er){cqrPageHost=""}

	try{
	  	cqrPageTitle = focusedWindow.document.title;
	}catch(er){cqrPageTitle=""}

    cqrLinkURL = findParentNode(event.originalTarget, "a");
    cqrAreaObj = findParentNode(event.originalTarget, "area");
    if (cqrAreaObj) cqrLinkURL = cqrAreaObj.href;
        cqrImgObj = findParentNode(event.originalTarget, "img");
    if (cqrImgObj){
        cqrImgURL = cqrAbsURI(cqrImgObj.baseURI, cqrImgObj.src);
        cqrImgName = getFNameFromURI(cqrImgURL);
    } else {
        cqrImgURL = "";
        cqrImgName = "";
    }
    if (!cqrLinkURL) {cqrLinkURL = ""}


}

function resetenv(){
	QueryHash = new Object();
	cqrPageSelection = "";
	cqrPageURL = "";
	cqrPageHost = "";
	cqrLinkURL = "";
	cqrImgName = "";
	cqrImgURL = "";
	cqrPageTitle = "";
	cqrAction = "";
	cqrConfigLastWillId = "";
	cqrConfigLastWillCtrl = false;
	cqrShowAlternatives = false;
	cqrcancel = false;
	cqrTabRef = "";
	cqrWndRef = "";
}
